/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2002-2008 by Y.D.K Co.,Ltd
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_support.S 1776 2010-04-05 11:12:59Z ertl-honda $
 */

/*
 *  ץå¸⥸塼 ֥Microblazeѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

/*
 *  ֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"
#include "microblaze_asm.inc"

/*
 * ٥ơ֥
 */
	.section .vectors.reset,"a"
	.global vectors_reset
vectors_reset:
	brai start           /* 0x00-0x04 Reset       */

	.section .vectors.sw_exception,"a"
	.global vectors_sw_exception
vectors_sw_exception:
	brai usrexcept_entry /* 0x08-0x0C User Vector */

	.section .vectors.interrupt,"a"
	.global vectors_interrupt
vectors_interrupt:
	brai interrupt_entry /* 0x10-14 Interrupt     */

	.section .vectors.hw_exception,"a"
	.global vectors_hw_exception
vectors_hw_exception:
	brai hwexcept_entry  /* 0x20-0x24 Break       */

	.section .vectors.reserve,"a"
	.global vectors_reserve
vectors_reserve:
	nop                  /* 0x28 Reserved         */
	nop                  /* 0x2C Reserved         */
	nop                  /* 0x30 Reserved         */
	nop                  /* 0x34 Reserved         */
	nop                  /* 0x38 Reserved         */
	nop                  /* 0x3C Reserved         */
	nop                  /* 0x40 Reserved         */
	nop                  /* 0x44 Reserved         */
	nop                  /* 0x48 Reserved         */
	nop                  /* 0x4C Reserved         */


/*
 *  桼㳰ȥ
 *  ͤr15äƤȤƥ꥿
 */
	.text
	.global usrexcept_entry
	.align 2
usrexcept_entry:
	rtsd r15, 8
	 nop


/*
 *  㳰ȥ
 */
	.text
	.global hwexcept_entry
	.align 2
hwexcept_entry:
	/*
	 * ƥȤ¸
	 * 襢ɥ쥹R17⤷BTRäƤ롥
	 * иΥɤߤȶ̲뤿ᡤR14γǼ
	 * ¸롥
	 */
	addik r1,r1,-64
	swi   r3,  r1, 60
	swi   r4,  r1, 56
	swi   r5,  r1, 52
	swi   r6,  r1, 48
	swi   r7,  r1, 44
	swi   r8,  r1, 40
	swi   r9,  r1, 36
	swi   r10, r1, 32
	swi   r11, r1, 28
	swi   r12, r1, 24
	swi   r17, r1, 20
	swi   r15, r1, 16
	swi   r16, r1, 12
	swi   r14, r1, 8
	swi   r18, r1, 4
	mfs   r3,  rmsr
	swi   r3,  r1, 0       /* Ѥ¸ */

	/*
	 *  ٱ䥹åȤǳߤȯˤϡ襢ɥ쥹ϡ
	 *  BTR˳Ǽ롥  
	 */
	mfs   r7,  resr        /* ESR  */
	andi  r4,  r7, ESR_DS  /* DSӥåȤåȤƤ */
	beqi  r4,  no_dslot    /* ǥ쥤åȤǤϤʤ     */
	mfs   r5,  rbtr        /* BTR  */
	swi   r5,  r1, 20      /* 襢ɥ쥹Ȥ¸     */
	Mov   r17, r5          /* 㳰ե졼뤿r17¸ */

no_dslot:
	/* 
	 * ߡ㳰ΥͥȲ1ʾʤ饹åڤؤʤ 
	 */
	lwi   r5,  r13, except_nest_count
	bgti  r5,  nest_int_exc      

	/*
	 * åݥڤؤ
	 */
	lwi   r4,  r2, _kernel_istkpt /* 󥿥ƥѤΥåɤ߹ */
	addik r4,  r4, -4             /* åݥ󥿤ǥ   */
	sw    r1,  r0, r4             /* å¸             */
	Mov   r1,  r4                 /* åݥڤؤ         */

nest_int_exc:
	/* 
	 * ߡ㳰ΥͥȲΥ󥯥
	 */
	addi  r6,  r5,  1 
	swi   r6,  r13, except_nest_count

	/*
	 * 㳰ե졼κ    
	 *                            եå
	 *    MSR(r3)                         0
	 *    ESR(r7)                         4
	 *    EAR(r6)                         8
	 *    ߡ㳰ͥȥ(r5) 12
	 *    ꥢɥ쥹(r17)              16
	 *    ͥ٥ޥ             20
	 */
	mfs   r4,  rear
	lbui  r6,  r13, iipm
	addik r1,  r1,  -24
	swi   r6,  r1,   20 
	swi   r17, r1,   16 
	swi   r5,  r1,   12 
	swi   r4,  r1,    8
	swi   r7,  r1,    4
	swi   r3,  r1,    0

	/*
	 *  㳰ե졼ƬϤCPU㳰ϥɥΰ
	 */
	Mov   r5,  r1         

	/*
	 *  CPU㳰ֹμ
	 */
	andi  r6,  r7, ESR_EC

	/*
	 *  㳰ϥɥ饢ɥ쥹μ
	 */
	add   r8,  r6, r6              /* 4ܤƥեåȤ    */
	add   r8,  r8, r8
	lwi   r7,  r8, exch_tbl

	/*
	 * 㳰(EE=1), 㳰楯ꥢ(EIP=0)Ȥ
	 */   
	ori   r8,  r3, MSR_EE
	andi  r8,  r8, ~(MSR_EIP)
	mts   rmsr,r8

#ifdef LOG_EXC_ENTER
	Push  r6         /* CPU㳰ֹ¸               */
	Push  r7         /* CPU㳰ϥɥ饢ɥ쥹¸   */
	Push  r5         /* CPU㳰ե졼Ƭ¸ */
	brlid r15, log_exc_enter
	 Mov   r5, r6    /* CPU㳰ֹˤ       */
	Pop   r5         /* CPU㳰ե졼Ƭ */
	Pop   r7        /* CPU㳰ϥɥ饢ɥ쥹   */
#endif /* LOG_EXC_ENTER */

	/* 
	 *  CPU㳰ϥɥƤӽФ 
	 */
	brald r15, r7             
	 nop

#ifdef LOG_EXC_LEAVE
	brlid r15, log_exc_leave
	 Pop   r5         /* CPU㳰ֹ               */
#endif /* LOG_EXC_LEAVE */

	/*
	 *  ߶ػ
	 */
	mfs   r3,  rmsr            
	andi  r3,  r3, ~MSR_IE
	mts   rmsr,r3

	/*
	 *  㳰ե졼ΤƤ
	 */
	addik r1,  r1,  20
	bri   ret_exc


/*
 *  ߥȥ
 */
	.text
	.global interrupt_entry
	.align 2
interrupt_entry:
	/*
	 * ƥȤ¸
	 */
	addik r1,r1,-64
	swi   r3,  r1, 60
	swi   r4,  r1, 56
	swi   r5,  r1, 52
	swi   r6,  r1, 48
	swi   r7,  r1, 44
	swi   r8,  r1, 40
	swi   r9,  r1, 36
	swi   r10, r1, 32
	swi   r11, r1, 28
	swi   r12, r1, 24
	swi   r14, r1, 20
	swi   r15, r1, 16
	swi   r16, r1, 12
	swi   r17, r1, 8
	swi   r18, r1, 4

	/* 
	 * msr¸ 
	 */
	mfs   r3,  rmsr
	swi   r3,  r1, 0

	/* 
	 * ߡ㳰ΥͥȲ1ʾʤ饹åڤؤʤ 
	 */
	lwi   r5,  r13, except_nest_count
	bgti  r5,  nest_int      

	/*
	 * åݥڤؤ
	 */
	lwi   r4,  r2, _kernel_istkpt /* 󥿥ƥѤΥåɤ߹ */
	addik r4,  r4, -4             /* åݥ󥿤ǥ   */
	sw    r1,  r0, r4             /* å¸             */
	Mov   r1,  r4                 /* åݥڤؤ         */


nest_int:
	/* 
	 * ߡ㳰ΥͥȲΥ󥯥
	 */
	addi  r5,  r5,  1 
	swi   r5,  r13, except_nest_count
                    
	/*
	 *  װμ
	 *  R5졤default_int_handler() ΰȤ롥
	 */
	lwi   r5,  r0, XINTC_IVR       /* ֹɤ߹             */

	/*
	 *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
	 *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
	 *  ¸롥
	 */
	lbui  r3,  r5,  inh_iipm_tbl  /* դߤγͥ٥ޥ */
	lbui  r6,  r13, iipm          /* ȯγͥ٥ޥ򥹥å */
	Push  r6
	sbi   r3,  r13, iipm          /* (ǥ)ͥ٥ޥ򥻥å */

	/*
	 *  XINTCդߤγͥ٤б
	 *  ޥӥåȤǥåȤ롥
	 */
	add   r6,  r3, r3                /* ͥ٥ޥ4ܤƥեåȤ    */
	add   r6,  r6, r6
	lwi   r7,  r6, iipm_mask_tbl     /* ͥ٥ޥб߶ػߥѥ */
	lwi   r8,  r13, idf              /* Ƴߤγ׵ػߥե饰ξ֤     */
	or    r7,  r7,  r8               /* ξԤOR                                 */
	xori  r7,  r7, -1                /* ȿž                                           */
	swi   r7,  r0, XINTC_IER         /* ꤷߤΤߵ                         */

	/*
	 *  ߥϥɥΥɥ쥹ɤ߹
	 */
	add   r4,  r5,  r5               /* ֹ4ܤƥեåȤ  */
	add   r4,  r4,  r4
	lwi   r6,  r4, inh_tbl           

	/*
	 *  ߵ
	 */
	mfs   r3,  rmsr
	ori   r3,  r3, MSR_IE
	mts   rmsr,r3

#ifdef LOG_INH_ENTER
	Push  r6           /* ϥɥ饢ɥ쥹¸ */
	Push  r5           /* ֹ¸ */
	brlid r15, log_inh_enter
	 nop   
	Pop   r5           /* ֹ */
	Pop   r6           /* ϥɥ饢ɥ쥹 */
	Push  r5           /* ֹ¸ */
#endif /* LOG_INH_ENTER */

	/* 
	 *  ߥϥɥƤӽФ 
	 */
	brald r15, r6
	 nop

#ifdef LOG_INH_LEAVE
	Pop  r5           /* ֹ */     
	brlid r15, log_inh_leave
	 nop
#endif /* LOG_INH_LEAVE */

	/*
	 *  ߶ػ
	 */
	mfs   r3,  rmsr            
	andi  r3,  r3, ~MSR_IE
	mts   rmsr,r3

/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåΥåˤ
 *  ֤ǸƤӽФ롥
 */
	.global ret_int
	.global ret_exc
rer_int:
ret_exc:
	/*
	 *  (ǥ)ͥ٥ޥ򸵤᤹
	 */
	Pop   r6
	sbi   r6,  r13, iipm             /* (ǥ)ͥ٥ޥ򥻥å */
	add   r5,  r6,  r6               /* ͥ٥ޥ4ܤƥեåȤ  */
	add   r5,  r5,  r5
	lwi   r7,  r5,  iipm_mask_tbl    /* ͥ٥ޥб߶ػߥѥ */
	lwi   r8,  r13, idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
	or    r8,  r7,  r8               /* ξԤOR                             */
	xori  r8,  r8,  -1               /* IER˥åȤ뤿ȿž              */
	swi   r8,  r0, XINTC_IER         /* ꤷߤΤߵ                     */

	/*
	 *  ߥͥȲΥǥ
	 */
	lwi   r5,  r13, except_nest_count
	addi  r5,  r5,  -1 
	swi   r5,  r13, except_nest_count

	bgti  r5,  ret_int_1            /* ͥȲ1ʾʤ */

	lw    r1,  r0, r1               /* åݥ󥿤᤹    */  
	lwi   r4,  r13, reqflg          /* reqflg Υå         */
	beqi  r4,  ret_int_1            /* false ʤ    */
	bri   ret_int_2                 /* true ʤ ret_int_2     */

ret_int_1:
	lwi  r3,  r1, 0
	lwi  r18, r1, 4
	lwi  r17, r1, 8
	lwi  r16, r1, 12
	lwi  r15, r1, 16
	lwi  r14, r1, 20
	lwi  r12, r1, 24
	lwi  r11, r1, 28
	lwi  r10, r1, 32
	lwi  r9,  r1, 36
	lwi  r8,  r1, 40
	lwi  r7,  r1, 44
	lwi  r6,  r1, 48
	lwi  r5,  r1, 52
	lwi  r4,  r1, 56

	/*
	 *  CPU㳰Υ꥿󤫤Ƚ
	 */
	andi r3,  r3, MSR_EIP
	bnei r3,  ret_int_1_EIP

	/*
	 *  ߤΥ꥿
	 */
	lwi  r3,  r1, 0
	mts  rmsr,r3
	lwi  r3,  r1, 60
	rtid r14,0 
	 addik r1,r1,64

	/*
	 *  CPU㳰Υ꥿
	 */
ret_int_1_EIP:
	lwi  r3,  r1, 0
	mts  rmsr,r3
	lwi  r3,  r1, 60
	rted r14,0 
	 addik r1,r1,64

	/*
	 *  ߥϥɥ/CPU㳰ϥɥи1
	 * 
	 *  Ǥϡ褬Ǥꡤåϡåξ
	 *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 *  ץåϡѡХ⡼ɡͥγߤػ
	 *  ֤ȤʤäƤ롥
	 */  
ret_int_2:
	swi  r0,  r13,  reqflg   /* reqflg  false  */

	/*
	 *  CPUå֤˰ܹԤ롥
	 *
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 *
	 *  MicrobalzeǤϡͥγߤߤʤᡤǤϡ
	 *  ä˲Ԥʤ
	 */

	/*
	 *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
	 *  ǥѥåԤʤΥåɬפʤΤϡ㳰
	 *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
	 *  reqflgtrueˤ뤿Ǥ롥
	 */
	lwi  r4,  r13,  p_runtsk   /* r4 <- p_runtsk        */
	lwi  r6,  r13,  dspflg     /* r6 <- dspflg          */
	beqi r6,  ret_int_3        /* dspflg  false ʤ ret_int_3  */
	lwi  r5,  r13,  p_schedtsk /* r5 <- p_schedtsk                  */
	sub  r6,  r5,   r4         /* p_runtsk  p_schedtsk Ʊʤ */
	beqi r6,  ret_int_3        /* ret_int_3                       */
	addi  r1,  r1,  -52        /* ĤΥ쥸¸          */
	swi   r19, r1,  48
	swi   r20, r1,  44
	swi   r21, r1,  40
	swi   r22, r1,  36
	swi   r23, r1,  32
	swi   r24, r1,  28
	swi   r25, r1,  24
	swi   r26, r1,  20
	swi   r27, r1,  16
	swi   r28, r1,  12
	swi   r29, r1,  8
	swi   r30, r1,  4
	swi   r31, r1,  0
	swi   r1 , r4,  TCB_sp     /* åTCB¸ */
	la    r6 , r0,  ret_int_r  /* ¹ԺƳϤ¸ */
	swi   r6 , r4,  TCB_pc     /* ¹ԺƳϤTCB¸   */
	bri   dispatcher

	/*
	 *  ߡ㳰ǥƥ¸롼
	 */
ret_int_r:
	lwi  r31,  r1,  0      
	lwi  r30,  r1,  4
	lwi  r29,  r1,  8
	lwi  r28,  r1,  12
	lwi  r27,  r1,  16
	lwi  r26,  r1,  20
	lwi  r25,  r1,  24
	lwi  r24,  r1,  28
	lwi  r23,  r1,  32
	lwi  r22,  r1,  36
	lwi  r21,  r1,  40
	lwi  r20,  r1,  44
	lwi  r19,  r1,  48
	addi r1,   r1,  52
	lwi  r3,   r1,   0
	mts  rmsr, r3                

ret_int_3:
	/*
	 * 㳰롼εư
	 * ret_int_r  dispatcher ƤӽФ뤿ᡤ
	 * tcb Υɥ쥹 r4 äƤ
	 */
	lbui r5,  r4,  TCB_enatex  /* r5 <- enatex                 */
	andi r6,  r5,  TCB_enatex_mask  
	beqi r6,  ret_int_4        /* enatex  false ʤ꥿ */
	lwi  r7,  r4,  TCB_texptn  /* r5 <- texptn                 */
	beqi r7,  ret_int_4        /* texptn  0 Ǥʤ       */
	brlid r15  call_texrtn     /* 㳰롼θƤӽФ */
	 nop

ret_int_4:
	lwi  r3,  r1, 0    /* MSR ᤹ʳIE=0ǳ߶ػߤˤʤ*/
	lwi  r18, r1, 4
	lwi  r17, r1, 8
	lwi  r16, r1, 12
	lwi  r15, r1, 16
	lwi  r14, r1, 20
	lwi  r12, r1, 24
	lwi  r11, r1, 28
	lwi  r10, r1, 32
	lwi  r9,  r1, 36
	lwi  r8,  r1, 40
	lwi  r7,  r1, 44
	lwi  r6,  r1, 48
	lwi  r5,  r1, 52
	lwi  r4,  r1, 56

	/*
	 *  CPU㳰Υ꥿󤫤Ƚ
	 */
	andi r3,  r3, MSR_EIP
	bnei r3,  ret_int_4_EIP

	/*
	 *  ߤΥ꥿
	 */
	lwi  r3,  r1, 0
	mts  rmsr,r3
	lwi  r3,  r1, 60
	rtid r14,0 
	 addik r1,r1,64

	/*
	 *  CPU㳰Υ꥿
	 */
ret_int_4_EIP:
	lwi  r3,  r1, 0
	mts  rmsr,r3
	lwi  r3,  r1, 60
	rted r14,0 
	 addik r1,r1,64


/*
 * ǥѥå
 */
	.global dispatch
	.align  2
dispatch:
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥
	 */
	addi  r1,  r1,  -64  /* å쥸ʳ¸ */
	swi   r15, r1,  60
	mfs   r3,  rmsr      /* msr¸                        */
	swi   r3,  r1,  56                
	swi   r18, r1,  52   
	swi   r19, r1,  48
	swi   r20, r1,  44
	swi   r21, r1,  40
	swi   r22, r1,  36
	swi   r23, r1,  32
	swi   r24, r1,  28
	swi   r25, r1,  24
	swi   r26, r1,  20
	swi   r27, r1,  16
	swi   r28, r1,  12
	swi   r29, r1,  8
	swi   r30, r1,  4
	swi   r31, r1,  0
	lwi   r4 , r13, p_runtsk   /* r4 <- p_runtsk */
	swi   r1 , r4,  TCB_sp 	   /* åTCB¸ */
	la    r5 , r0,  dispatch_r /* ¹ԺƳϤ¸ */
	swi   r5 , r4,  TCB_pc     /* ¹ԺƳϤTCB¸   */
	bri   dispatcher

dispatch_r:
	lwi  r31,  r1, 0      /* 쥸 */
	lwi  r30,  r1, 4
	lwi  r29,  r1, 8
	lwi  r28,  r1, 12
	lwi  r27,  r1, 16
	lwi  r26,  r1, 20
	lwi  r25,  r1, 24
	lwi  r24,  r1, 28
	lwi  r23,  r1, 32
	lwi  r22,  r1, 36
	lwi  r21,  r1, 40
	lwi  r20,  r1, 44
	lwi  r19,  r1, 48
	lwi  r18,  r1, 52
	lwi  r3,   r1, 56   
	mts  rmsr,r3            
	addi r1,   r1, 60   /* åݥ󥿤᤹ */

	/*
	 *  㳰롼εư
	 *  dispatch_r  dispatcher ƤӽФ뤿ᡤ
	 *  tcb Υɥ쥹 r4 äƤ
	 */
	lbui r5,  r4,  TCB_enatex  /* r5 <- enatex                 */
	andi r6,  r5,  TCB_enatex_mask  
	beqi r6,  dispatch_r_1     /* enatex  false ʤ꥿ */
	lwi  r7,  r4,  TCB_texptn  /* r5 <- texptn                 */
	beqi r7,  dispatch_r_1     /* texptn  0 Ǥʤ       */
	brlid r15  call_texrtn     /* 㳰롼θƤӽФ */
	 nop
dispatch_r_1:
	Pop     r15
	rtsd	r15, 8
	 nop

/*
 *  ǥѥåư
 */
    .globl start_dispatch
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  dispatcherϡCPUå֡ʥǥΡ˳ͥ٥ޥ
	 *  ֡㳰ʳ/CPU㳰ˤΥͥȲ0ǸƤӽФ     
	 *  target_initializeǤϡʥǥΡ˳ͥ٥ޥ
	 *  ȤͥγߤǤFIQĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */ 
	/* 㳰ʳ/CPU㳰ˤΥͥȲ򥯥ꥢ */
	swi   r0,  r13, except_nest_count

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl exit_and_dispatch
exit_and_dispatch:
	/* ǥѥåΡdispatcherˤ */  

/*
 *  ǥѥå
 */
dispatcher:
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
	 */
#ifdef LOG_DSP_ENTER
	brlid r15, log_dsp_enter
	 lwi  r5,  r13, p_runtsk  /* r5 <- p_schedtsk            */
#endif /* LOG_DSP_ENTER */

dispatcher_0:
	lwi  r4,  r13, p_schedtsk /* r4 <- p_schedtsk            */
	swi  r4,  r13, p_runtsk   /* p_schedtsk  runtsk      */        
	beqi r4,  dispatcher_1    /* p_schedtsk 뤫         */
	lwi  r1,  r4,  TCB_sp     /* TCB饿å */

#ifdef LOG_DSP_ENTER
	Push r4
	brlid r15, log_dsp_leave
	 Mov   r5, r4
	Pop  r4
#endif /* LOG_DSP_ENTER */

	lwi  r5,  r4,  TCB_pc     /* TCB¹ԺƳϤ   */
	bra  r5
dispatcher_1:
	/*
	 * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 * 򤹤
	 */
	lwi   r1,   r2,  _kernel_istkpt   /* 󥿥ƥѤΥåɤ߹ */
	la    r6,   r0,  1                /* except_nest_count 1                    */
	swi   r6,   r13, except_nest_count
	andi  r4,   r3, ~MSR_IE           /* IE = '0'               */
dispatcher_2:
	/*
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
	 *
	 *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
	 *  ߽ˤɤΥåȤȤβȡ
	 *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ롥
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *
	 *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
	 *  ݤưͤ˹פʤʤ롥
	 *
	 */
	mfs   r3,   rmsr                 /* ߵ(MSR(IE)򥻥å)      */
	ori   r5,   r3, MSR_IE            
	mts   rmsr, r5
	nop
	nop
	mfs   r3,   rmsr                 /* ߶ػ(MSR(IE)򥯥ꥢ)      */
	andi  r5,   r3, ~MSR_IE            
	mts   rmsr, r5
	lwi   r6,  r13,  reqflg           /* r6 <- reqflg                     */
	beqi  r6,  dispatcher_2           /* reqflg  false ʤ             */
	swi   r0,  r13, except_nest_count /* except_nest_count 򥯥ꥢ       */
	swi   r0,  r13,  reqflg           /* reqflg  false                */
	bri   dispatcher_0

/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    .globl call_exit_kernel
call_exit_kernel:
	lwi   r1,  r2,  _kernel_istkpt /* 󥿥ƥѤΥåɤ߹ */
	brlid r15  exit_kernel         
	 nop

/*
 *  ϻ
 *
 *  åμ
 *  Microblaze Processor Reference Guide 5253
 *  ؿƽФΰϡr5r10 ˳Ǽ롥
 *  Ʊ˸ƽФϥåե졼˰γǼݤɬ
 *  롥ˤξˤϥ󥯥쥸(R15)ʬΰ褬ɬפȤʤ롥
 *  ƽФϹ¾δؿƤӽФ r5r10 򤳤ΰ¸
 * 롥
 *  Low Address
 *             --------------------
 *  new_sp -> | Link Register(R15) |
 *             --------------------
 *            |   Arg1Ѥΰ     |
 *             --------------------
 *            |   Arg2Ѥΰ     |
 *             --------------------        
 *            |      ....          |
 *             --------------------
 *  High Address
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹 r4 äƤ
 */
	.text
	.global start_r
	.align 2
start_r:
	mfs   r3,   rmsr              /* ߵ(MSR(IE)򥻥å)   */
	ori   r5,   r3, MSR_IE            
	mts   rmsr, r5
	lwi   r3,  r4, TCB_p_tinib    /* r3  <- p_runtsk->p_tinib      */
	lwi   r5,  r3, TINIB_exinf    /* r5  <- exinf          */
	lwi   r11, r3, TINIB_task     /* r11 <- μ¹       */
	la    r15, r0, (ext_tsk - 8)  /* (ext_tsk)   */
	Push  r5                      /* åΰ        */
	Push  r15
	bra   r11                     /* μ¹Գ              */

/*
 * Ԥ
 */
	.global sil_dly_nse
sil_dly_nse:
	addi   r5, r5, -SIL_DLY_TIM1
	bgti   r5, sil_dly_nse_1
	rtsd   r15, 8
	nop  
sil_dly_nse_1:
	addi   r5, r5, -SIL_DLY_TIM2
	bgti   r5, sil_dly_nse_1
	rtsd   r15, 8
	 nop          
